# Copyright 2019 the V8 project authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can
# be found in the LICENSE file.

# This file is automatically generated by mkgrokdump and should not
# be modified manually.

# List of known V8 instance types.
INSTANCE_TYPES = {
  0: "INTERNALIZED_STRING_TYPE",
  2: "EXTERNAL_INTERNALIZED_STRING_TYPE",
  8: "ONE_BYTE_INTERNALIZED_STRING_TYPE",
  10: "EXTERNAL_ONE_BYTE_INTERNALIZED_STRING_TYPE",
  18: "UNCACHED_EXTERNAL_INTERNALIZED_STRING_TYPE",
  26: "UNCACHED_EXTERNAL_ONE_BYTE_INTERNALIZED_STRING_TYPE",
  32: "STRING_TYPE",
  33: "CONS_STRING_TYPE",
  34: "EXTERNAL_STRING_TYPE",
  35: "SLICED_STRING_TYPE",
  37: "THIN_STRING_TYPE",
  40: "ONE_BYTE_STRING_TYPE",
  41: "CONS_ONE_BYTE_STRING_TYPE",
  42: "EXTERNAL_ONE_BYTE_STRING_TYPE",
  43: "SLICED_ONE_BYTE_STRING_TYPE",
  45: "THIN_ONE_BYTE_STRING_TYPE",
  50: "UNCACHED_EXTERNAL_STRING_TYPE",
  58: "UNCACHED_EXTERNAL_ONE_BYTE_STRING_TYPE",
  64: "SYMBOL_TYPE",
  65: "HEAP_NUMBER_TYPE",
  66: "BIGINT_TYPE",
  67: "ODDBALL_TYPE",
  68: "MAP_TYPE",
  69: "CODE_TYPE",
  70: "MUTABLE_HEAP_NUMBER_TYPE",
  71: "FOREIGN_TYPE",
  72: "BYTE_ARRAY_TYPE",
  73: "BYTECODE_ARRAY_TYPE",
  74: "FREE_SPACE_TYPE",
  75: "FIXED_DOUBLE_ARRAY_TYPE",
  76: "FEEDBACK_METADATA_TYPE",
  77: "FILLER_TYPE",
  78: "ACCESS_CHECK_INFO_TYPE",
  79: "ACCESSOR_INFO_TYPE",
  80: "ACCESSOR_PAIR_TYPE",
  81: "ALIASED_ARGUMENTS_ENTRY_TYPE",
  82: "ALLOCATION_MEMENTO_TYPE",
  83: "ASM_WASM_DATA_TYPE",
  84: "ASYNC_GENERATOR_REQUEST_TYPE",
  85: "CLASS_POSITIONS_TYPE",
  86: "DEBUG_INFO_TYPE",
  87: "ENUM_CACHE_TYPE",
  88: "FUNCTION_TEMPLATE_INFO_TYPE",
  89: "FUNCTION_TEMPLATE_RARE_DATA_TYPE",
  90: "INTERCEPTOR_INFO_TYPE",
  91: "INTERPRETER_DATA_TYPE",
  92: "MODULE_INFO_ENTRY_TYPE",
  93: "MODULE_TYPE",
  94: "OBJECT_TEMPLATE_INFO_TYPE",
  95: "PROMISE_CAPABILITY_TYPE",
  96: "PROMISE_REACTION_TYPE",
  97: "PROTOTYPE_INFO_TYPE",
  98: "SCRIPT_TYPE",
  99: "SOURCE_POSITION_TABLE_WITH_FRAME_CACHE_TYPE",
  100: "STACK_FRAME_INFO_TYPE",
  101: "STACK_TRACE_FRAME_TYPE",
  102: "TEMPLATE_OBJECT_DESCRIPTION_TYPE",
  103: "TUPLE2_TYPE",
  104: "TUPLE3_TYPE",
  105: "ARRAY_BOILERPLATE_DESCRIPTION_TYPE",
  106: "WASM_CAPI_FUNCTION_DATA_TYPE",
  107: "WASM_DEBUG_INFO_TYPE",
  108: "WASM_EXCEPTION_TAG_TYPE",
  109: "WASM_EXPORTED_FUNCTION_DATA_TYPE",
  110: "WASM_JS_FUNCTION_DATA_TYPE",
  111: "CALLABLE_TASK_TYPE",
  112: "CALLBACK_TASK_TYPE",
  113: "PROMISE_FULFILL_REACTION_JOB_TASK_TYPE",
  114: "PROMISE_REJECT_REACTION_JOB_TASK_TYPE",
  115: "PROMISE_RESOLVE_THENABLE_JOB_TASK_TYPE",
  116: "FINALIZATION_GROUP_CLEANUP_JOB_TASK_TYPE",
  117: "ALLOCATION_SITE_TYPE",
  118: "EMBEDDER_DATA_ARRAY_TYPE",
  119: "FIXED_ARRAY_TYPE",
  120: "OBJECT_BOILERPLATE_DESCRIPTION_TYPE",
  121: "CLOSURE_FEEDBACK_CELL_ARRAY_TYPE",
  122: "HASH_TABLE_TYPE",
  123: "ORDERED_HASH_MAP_TYPE",
  124: "ORDERED_HASH_SET_TYPE",
  125: "ORDERED_NAME_DICTIONARY_TYPE",
  126: "NAME_DICTIONARY_TYPE",
  127: "GLOBAL_DICTIONARY_TYPE",
  128: "NUMBER_DICTIONARY_TYPE",
  129: "SIMPLE_NUMBER_DICTIONARY_TYPE",
  130: "STRING_TABLE_TYPE",
  131: "EPHEMERON_HASH_TABLE_TYPE",
  132: "SCOPE_INFO_TYPE",
  133: "SCRIPT_CONTEXT_TABLE_TYPE",
  134: "AWAIT_CONTEXT_TYPE",
  135: "BLOCK_CONTEXT_TYPE",
  136: "CATCH_CONTEXT_TYPE",
  137: "DEBUG_EVALUATE_CONTEXT_TYPE",
  138: "EVAL_CONTEXT_TYPE",
  139: "FUNCTION_CONTEXT_TYPE",
  140: "MODULE_CONTEXT_TYPE",
  141: "NATIVE_CONTEXT_TYPE",
  142: "SCRIPT_CONTEXT_TYPE",
  143: "WITH_CONTEXT_TYPE",
  144: "WEAK_FIXED_ARRAY_TYPE",
  145: "TRANSITION_ARRAY_TYPE",
  146: "CALL_HANDLER_INFO_TYPE",
  147: "CELL_TYPE",
  148: "CODE_DATA_CONTAINER_TYPE",
  149: "DESCRIPTOR_ARRAY_TYPE",
  150: "FEEDBACK_CELL_TYPE",
  151: "FEEDBACK_VECTOR_TYPE",
  152: "LOAD_HANDLER_TYPE",
  153: "PREPARSE_DATA_TYPE",
  154: "PROPERTY_ARRAY_TYPE",
  155: "PROPERTY_CELL_TYPE",
  156: "SHARED_FUNCTION_INFO_TYPE",
  157: "SMALL_ORDERED_HASH_MAP_TYPE",
  158: "SMALL_ORDERED_HASH_SET_TYPE",
  159: "SMALL_ORDERED_NAME_DICTIONARY_TYPE",
  160: "STORE_HANDLER_TYPE",
  161: "UNCOMPILED_DATA_WITHOUT_PREPARSE_DATA_TYPE",
  162: "UNCOMPILED_DATA_WITH_PREPARSE_DATA_TYPE",
  163: "WEAK_ARRAY_LIST_TYPE",
  164: "WEAK_CELL_TYPE",
  1024: "JS_PROXY_TYPE",
  1025: "JS_GLOBAL_OBJECT_TYPE",
  1026: "JS_GLOBAL_PROXY_TYPE",
  1027: "JS_MODULE_NAMESPACE_TYPE",
  1040: "JS_SPECIAL_API_OBJECT_TYPE",
  1041: "JS_VALUE_TYPE",
  1056: "JS_API_OBJECT_TYPE",
  1057: "JS_OBJECT_TYPE",
  1058: "JS_ARGUMENTS_TYPE",
  1059: "JS_ARRAY_BUFFER_TYPE",
  1060: "JS_ARRAY_ITERATOR_TYPE",
  1061: "JS_ARRAY_TYPE",
  1062: "JS_ASYNC_FROM_SYNC_ITERATOR_TYPE",
  1063: "JS_ASYNC_FUNCTION_OBJECT_TYPE",
  1064: "JS_ASYNC_GENERATOR_OBJECT_TYPE",
  1065: "JS_CONTEXT_EXTENSION_OBJECT_TYPE",
  1066: "JS_DATE_TYPE",
  1067: "JS_ERROR_TYPE",
  1068: "JS_GENERATOR_OBJECT_TYPE",
  1069: "JS_MAP_TYPE",
  1070: "JS_MAP_KEY_ITERATOR_TYPE",
  1071: "JS_MAP_KEY_VALUE_ITERATOR_TYPE",
  1072: "JS_MAP_VALUE_ITERATOR_TYPE",
  1073: "JS_MESSAGE_OBJECT_TYPE",
  1074: "JS_PROMISE_TYPE",
  1075: "JS_REGEXP_TYPE",
  1076: "JS_REGEXP_STRING_ITERATOR_TYPE",
  1077: "JS_SET_TYPE",
  1078: "JS_SET_KEY_VALUE_ITERATOR_TYPE",
  1079: "JS_SET_VALUE_ITERATOR_TYPE",
  1080: "JS_STRING_ITERATOR_TYPE",
  1081: "JS_WEAK_REF_TYPE",
  1082: "JS_FINALIZATION_GROUP_CLEANUP_ITERATOR_TYPE",
  1083: "JS_FINALIZATION_GROUP_TYPE",
  1084: "JS_WEAK_MAP_TYPE",
  1085: "JS_WEAK_SET_TYPE",
  1086: "JS_TYPED_ARRAY_TYPE",
  1087: "JS_DATA_VIEW_TYPE",
  1088: "JS_INTL_V8_BREAK_ITERATOR_TYPE",
  1089: "JS_INTL_COLLATOR_TYPE",
  1090: "JS_INTL_DATE_TIME_FORMAT_TYPE",
  1091: "JS_INTL_LIST_FORMAT_TYPE",
  1092: "JS_INTL_LOCALE_TYPE",
  1093: "JS_INTL_NUMBER_FORMAT_TYPE",
  1094: "JS_INTL_PLURAL_RULES_TYPE",
  1095: "JS_INTL_RELATIVE_TIME_FORMAT_TYPE",
  1096: "JS_INTL_SEGMENT_ITERATOR_TYPE",
  1097: "JS_INTL_SEGMENTER_TYPE",
  1098: "WASM_EXCEPTION_TYPE",
  1099: "WASM_GLOBAL_TYPE",
  1100: "WASM_INSTANCE_TYPE",
  1101: "WASM_MEMORY_TYPE",
  1102: "WASM_MODULE_TYPE",
  1103: "WASM_TABLE_TYPE",
  1104: "JS_BOUND_FUNCTION_TYPE",
  1105: "JS_FUNCTION_TYPE",
}

# List of known V8 maps.
KNOWN_MAPS = {
  ("read_only_space", 0x00139): (74, "FreeSpaceMap"),
  ("read_only_space", 0x00189): (68, "MetaMap"),
  ("read_only_space", 0x00209): (67, "NullMap"),
  ("read_only_space", 0x00271): (149, "DescriptorArrayMap"),
  ("read_only_space", 0x002d1): (144, "WeakFixedArrayMap"),
  ("read_only_space", 0x00321): (77, "OnePointerFillerMap"),
  ("read_only_space", 0x00371): (77, "TwoPointerFillerMap"),
  ("read_only_space", 0x003f1): (67, "UninitializedMap"),
  ("read_only_space", 0x00461): (8, "OneByteInternalizedStringMap"),
  ("read_only_space", 0x00501): (67, "UndefinedMap"),
  ("read_only_space", 0x00561): (65, "HeapNumberMap"),
  ("read_only_space", 0x005e1): (67, "TheHoleMap"),
  ("read_only_space", 0x00689): (67, "BooleanMap"),
  ("read_only_space", 0x00761): (72, "ByteArrayMap"),
  ("read_only_space", 0x007b1): (119, "FixedArrayMap"),
  ("read_only_space", 0x00801): (119, "FixedCOWArrayMap"),
  ("read_only_space", 0x00851): (122, "HashTableMap"),
  ("read_only_space", 0x008a1): (64, "SymbolMap"),
  ("read_only_space", 0x008f1): (40, "OneByteStringMap"),
  ("read_only_space", 0x00941): (132, "ScopeInfoMap"),
  ("read_only_space", 0x00991): (156, "SharedFunctionInfoMap"),
  ("read_only_space", 0x009e1): (69, "CodeMap"),
  ("read_only_space", 0x00a31): (139, "FunctionContextMap"),
  ("read_only_space", 0x00a81): (147, "CellMap"),
  ("read_only_space", 0x00ad1): (155, "GlobalPropertyCellMap"),
  ("read_only_space", 0x00b21): (71, "ForeignMap"),
  ("read_only_space", 0x00b71): (145, "TransitionArrayMap"),
  ("read_only_space", 0x00bc1): (151, "FeedbackVectorMap"),
  ("read_only_space", 0x00c61): (67, "ArgumentsMarkerMap"),
  ("read_only_space", 0x00d01): (67, "ExceptionMap"),
  ("read_only_space", 0x00da1): (67, "TerminationExceptionMap"),
  ("read_only_space", 0x00e49): (67, "OptimizedOutMap"),
  ("read_only_space", 0x00ee9): (67, "StaleRegisterMap"),
  ("read_only_space", 0x00f59): (141, "NativeContextMap"),
  ("read_only_space", 0x00fa9): (140, "ModuleContextMap"),
  ("read_only_space", 0x00ff9): (138, "EvalContextMap"),
  ("read_only_space", 0x01049): (142, "ScriptContextMap"),
  ("read_only_space", 0x01099): (134, "AwaitContextMap"),
  ("read_only_space", 0x010e9): (135, "BlockContextMap"),
  ("read_only_space", 0x01139): (136, "CatchContextMap"),
  ("read_only_space", 0x01189): (143, "WithContextMap"),
  ("read_only_space", 0x011d9): (137, "DebugEvaluateContextMap"),
  ("read_only_space", 0x01229): (133, "ScriptContextTableMap"),
  ("read_only_space", 0x01279): (121, "ClosureFeedbackCellArrayMap"),
  ("read_only_space", 0x012c9): (76, "FeedbackMetadataArrayMap"),
  ("read_only_space", 0x01319): (119, "ArrayListMap"),
  ("read_only_space", 0x01369): (66, "BigIntMap"),
  ("read_only_space", 0x013b9): (120, "ObjectBoilerplateDescriptionMap"),
  ("read_only_space", 0x01409): (73, "BytecodeArrayMap"),
  ("read_only_space", 0x01459): (148, "CodeDataContainerMap"),
  ("read_only_space", 0x014a9): (75, "FixedDoubleArrayMap"),
  ("read_only_space", 0x014f9): (127, "GlobalDictionaryMap"),
  ("read_only_space", 0x01549): (150, "ManyClosuresCellMap"),
  ("read_only_space", 0x01599): (119, "ModuleInfoMap"),
  ("read_only_space", 0x015e9): (70, "MutableHeapNumberMap"),
  ("read_only_space", 0x01639): (126, "NameDictionaryMap"),
  ("read_only_space", 0x01689): (150, "NoClosuresCellMap"),
  ("read_only_space", 0x016d9): (128, "NumberDictionaryMap"),
  ("read_only_space", 0x01729): (150, "OneClosureCellMap"),
  ("read_only_space", 0x01779): (123, "OrderedHashMapMap"),
  ("read_only_space", 0x017c9): (124, "OrderedHashSetMap"),
  ("read_only_space", 0x01819): (125, "OrderedNameDictionaryMap"),
  ("read_only_space", 0x01869): (153, "PreparseDataMap"),
  ("read_only_space", 0x018b9): (154, "PropertyArrayMap"),
  ("read_only_space", 0x01909): (146, "SideEffectCallHandlerInfoMap"),
  ("read_only_space", 0x01959): (146, "SideEffectFreeCallHandlerInfoMap"),
  ("read_only_space", 0x019a9): (146, "NextCallSideEffectFreeCallHandlerInfoMap"),
  ("read_only_space", 0x019f9): (129, "SimpleNumberDictionaryMap"),
  ("read_only_space", 0x01a49): (119, "SloppyArgumentsElementsMap"),
  ("read_only_space", 0x01a99): (157, "SmallOrderedHashMapMap"),
  ("read_only_space", 0x01ae9): (158, "SmallOrderedHashSetMap"),
  ("read_only_space", 0x01b39): (159, "SmallOrderedNameDictionaryMap"),
  ("read_only_space", 0x01b89): (130, "StringTableMap"),
  ("read_only_space", 0x01bd9): (161, "UncompiledDataWithoutPreparseDataMap"),
  ("read_only_space", 0x01c29): (162, "UncompiledDataWithPreparseDataMap"),
  ("read_only_space", 0x01c79): (163, "WeakArrayListMap"),
  ("read_only_space", 0x01cc9): (131, "EphemeronHashTableMap"),
  ("read_only_space", 0x01d19): (118, "EmbedderDataArrayMap"),
  ("read_only_space", 0x01d69): (164, "WeakCellMap"),
  ("read_only_space", 0x01db9): (58, "NativeSourceStringMap"),
  ("read_only_space", 0x01e09): (32, "StringMap"),
  ("read_only_space", 0x01e59): (41, "ConsOneByteStringMap"),
  ("read_only_space", 0x01ea9): (33, "ConsStringMap"),
  ("read_only_space", 0x01ef9): (45, "ThinOneByteStringMap"),
  ("read_only_space", 0x01f49): (37, "ThinStringMap"),
  ("read_only_space", 0x01f99): (35, "SlicedStringMap"),
  ("read_only_space", 0x01fe9): (43, "SlicedOneByteStringMap"),
  ("read_only_space", 0x02039): (34, "ExternalStringMap"),
  ("read_only_space", 0x02089): (42, "ExternalOneByteStringMap"),
  ("read_only_space", 0x020d9): (50, "UncachedExternalStringMap"),
  ("read_only_space", 0x02129): (0, "InternalizedStringMap"),
  ("read_only_space", 0x02179): (2, "ExternalInternalizedStringMap"),
  ("read_only_space", 0x021c9): (10, "ExternalOneByteInternalizedStringMap"),
  ("read_only_space", 0x02219): (18, "UncachedExternalInternalizedStringMap"),
  ("read_only_space", 0x02269): (26, "UncachedExternalOneByteInternalizedStringMap"),
  ("read_only_space", 0x022b9): (58, "UncachedExternalOneByteStringMap"),
  ("read_only_space", 0x02309): (67, "SelfReferenceMarkerMap"),
  ("read_only_space", 0x02371): (87, "EnumCacheMap"),
  ("read_only_space", 0x02411): (105, "ArrayBoilerplateDescriptionMap"),
  ("read_only_space", 0x02601): (90, "InterceptorInfoMap"),
  ("read_only_space", 0x04de1): (78, "AccessCheckInfoMap"),
  ("read_only_space", 0x04e31): (79, "AccessorInfoMap"),
  ("read_only_space", 0x04e81): (80, "AccessorPairMap"),
  ("read_only_space", 0x04ed1): (81, "AliasedArgumentsEntryMap"),
  ("read_only_space", 0x04f21): (82, "AllocationMementoMap"),
  ("read_only_space", 0x04f71): (83, "AsmWasmDataMap"),
  ("read_only_space", 0x04fc1): (84, "AsyncGeneratorRequestMap"),
  ("read_only_space", 0x05011): (85, "ClassPositionsMap"),
  ("read_only_space", 0x05061): (86, "DebugInfoMap"),
  ("read_only_space", 0x050b1): (88, "FunctionTemplateInfoMap"),
  ("read_only_space", 0x05101): (89, "FunctionTemplateRareDataMap"),
  ("read_only_space", 0x05151): (91, "InterpreterDataMap"),
  ("read_only_space", 0x051a1): (92, "ModuleInfoEntryMap"),
  ("read_only_space", 0x051f1): (93, "ModuleMap"),
  ("read_only_space", 0x05241): (94, "ObjectTemplateInfoMap"),
  ("read_only_space", 0x05291): (95, "PromiseCapabilityMap"),
  ("read_only_space", 0x052e1): (96, "PromiseReactionMap"),
  ("read_only_space", 0x05331): (97, "PrototypeInfoMap"),
  ("read_only_space", 0x05381): (98, "ScriptMap"),
  ("read_only_space", 0x053d1): (99, "SourcePositionTableWithFrameCacheMap"),
  ("read_only_space", 0x05421): (100, "StackFrameInfoMap"),
  ("read_only_space", 0x05471): (101, "StackTraceFrameMap"),
  ("read_only_space", 0x054c1): (102, "TemplateObjectDescriptionMap"),
  ("read_only_space", 0x05511): (103, "Tuple2Map"),
  ("read_only_space", 0x05561): (104, "Tuple3Map"),
  ("read_only_space", 0x055b1): (106, "WasmCapiFunctionDataMap"),
  ("read_only_space", 0x05601): (107, "WasmDebugInfoMap"),
  ("read_only_space", 0x05651): (108, "WasmExceptionTagMap"),
  ("read_only_space", 0x056a1): (109, "WasmExportedFunctionDataMap"),
  ("read_only_space", 0x056f1): (110, "WasmJSFunctionDataMap"),
  ("read_only_space", 0x05741): (111, "CallableTaskMap"),
  ("read_only_space", 0x05791): (112, "CallbackTaskMap"),
  ("read_only_space", 0x057e1): (113, "PromiseFulfillReactionJobTaskMap"),
  ("read_only_space", 0x05831): (114, "PromiseRejectReactionJobTaskMap"),
  ("read_only_space", 0x05881): (115, "PromiseResolveThenableJobTaskMap"),
  ("read_only_space", 0x058d1): (116, "FinalizationGroupCleanupJobTaskMap"),
  ("read_only_space", 0x05921): (117, "AllocationSiteWithWeakNextMap"),
  ("read_only_space", 0x05971): (117, "AllocationSiteWithoutWeakNextMap"),
  ("read_only_space", 0x059c1): (152, "LoadHandler1Map"),
  ("read_only_space", 0x05a11): (152, "LoadHandler2Map"),
  ("read_only_space", 0x05a61): (152, "LoadHandler3Map"),
  ("read_only_space", 0x05ab1): (160, "StoreHandler0Map"),
  ("read_only_space", 0x05b01): (160, "StoreHandler1Map"),
  ("read_only_space", 0x05b51): (160, "StoreHandler2Map"),
  ("read_only_space", 0x05ba1): (160, "StoreHandler3Map"),
  ("map_space", 0x00139): (1057, "ExternalMap"),
  ("map_space", 0x00189): (1073, "JSMessageObjectMap"),
}

# List of known V8 objects.
KNOWN_OBJECTS = {
  ("read_only_space", 0x001d9): "NullValue",
  ("read_only_space", 0x00259): "EmptyDescriptorArray",
  ("read_only_space", 0x002c1): "EmptyWeakFixedArray",
  ("read_only_space", 0x003c1): "UninitializedValue",
  ("read_only_space", 0x004d1): "UndefinedValue",
  ("read_only_space", 0x00551): "NanValue",
  ("read_only_space", 0x005b1): "TheHoleValue",
  ("read_only_space", 0x00649): "HoleNanValue",
  ("read_only_space", 0x00659): "TrueValue",
  ("read_only_space", 0x00709): "FalseValue",
  ("read_only_space", 0x00751): "empty_string",
  ("read_only_space", 0x00c11): "EmptyScopeInfo",
  ("read_only_space", 0x00c21): "EmptyFixedArray",
  ("read_only_space", 0x00c31): "ArgumentsMarker",
  ("read_only_space", 0x00cd1): "Exception",
  ("read_only_space", 0x00d71): "TerminationException",
  ("read_only_space", 0x00e19): "OptimizedOut",
  ("read_only_space", 0x00eb9): "StaleRegister",
  ("read_only_space", 0x02359): "EmptyEnumCache",
  ("read_only_space", 0x023c1): "EmptyPropertyArray",
  ("read_only_space", 0x023d1): "EmptyByteArray",
  ("read_only_space", 0x023e1): "EmptyObjectBoilerplateDescription",
  ("read_only_space", 0x023f9): "EmptyArrayBoilerplateDescription",
  ("read_only_space", 0x02461): "EmptyClosureFeedbackCellArray",
  ("read_only_space", 0x02471): "EmptySloppyArgumentsElements",
  ("read_only_space", 0x02491): "EmptySlowElementDictionary",
  ("read_only_space", 0x024d9): "EmptyOrderedHashMap",
  ("read_only_space", 0x02501): "EmptyOrderedHashSet",
  ("read_only_space", 0x02529): "EmptyFeedbackMetadata",
  ("read_only_space", 0x02539): "EmptyPropertyCell",
  ("read_only_space", 0x02561): "EmptyPropertyDictionary",
  ("read_only_space", 0x025b1): "NoOpInterceptorInfo",
  ("read_only_space", 0x02651): "EmptyWeakArrayList",
  ("read_only_space", 0x02669): "InfinityValue",
  ("read_only_space", 0x02679): "MinusZeroValue",
  ("read_only_space", 0x02689): "MinusInfinityValue",
  ("read_only_space", 0x02699): "SelfReferenceMarker",
  ("read_only_space", 0x026f1): "OffHeapTrampolineRelocationInfo",
  ("read_only_space", 0x02709): "TrampolineTrivialCodeDataContainer",
  ("read_only_space", 0x02721): "TrampolinePromiseRejectionCodeDataContainer",
  ("read_only_space", 0x02739): "HashSeed",
  ("old_space", 0x00139): "ArgumentsIteratorAccessor",
  ("old_space", 0x001a9): "ArrayLengthAccessor",
  ("old_space", 0x00219): "BoundFunctionLengthAccessor",
  ("old_space", 0x00289): "BoundFunctionNameAccessor",
  ("old_space", 0x002f9): "ErrorStackAccessor",
  ("old_space", 0x00369): "FunctionArgumentsAccessor",
  ("old_space", 0x003d9): "FunctionCallerAccessor",
  ("old_space", 0x00449): "FunctionNameAccessor",
  ("old_space", 0x004b9): "FunctionLengthAccessor",
  ("old_space", 0x00529): "FunctionPrototypeAccessor",
  ("old_space", 0x00599): "StringLengthAccessor",
  ("old_space", 0x00609): "InvalidPrototypeValidityCell",
  ("old_space", 0x00619): "EmptyScript",
  ("old_space", 0x00699): "ManyClosuresCell",
  ("old_space", 0x006b1): "ArrayConstructorProtector",
  ("old_space", 0x006c1): "NoElementsProtector",
  ("old_space", 0x006e9): "IsConcatSpreadableProtector",
  ("old_space", 0x006f9): "ArraySpeciesProtector",
  ("old_space", 0x00721): "TypedArraySpeciesProtector",
  ("old_space", 0x00749): "RegExpSpeciesProtector",
  ("old_space", 0x00771): "PromiseSpeciesProtector",
  ("old_space", 0x00799): "StringLengthProtector",
  ("old_space", 0x007a9): "ArrayIteratorProtector",
  ("old_space", 0x007d1): "ArrayBufferDetachingProtector",
  ("old_space", 0x007f9): "PromiseHookProtector",
  ("old_space", 0x00821): "PromiseResolveProtector",
  ("old_space", 0x00831): "MapIteratorProtector",
  ("old_space", 0x00859): "PromiseThenProtector",
  ("old_space", 0x00881): "SetIteratorProtector",
  ("old_space", 0x008a9): "StringIteratorProtector",
  ("old_space", 0x008d1): "SingleCharacterStringCache",
  ("old_space", 0x010e1): "StringSplitCache",
  ("old_space", 0x018f1): "RegExpMultipleCache",
  ("old_space", 0x02101): "BuiltinsConstantsTable",
}

# List of known V8 Frame Markers.
FRAME_MARKERS = (
  "ENTRY",
  "CONSTRUCT_ENTRY",
  "EXIT",
  "OPTIMIZED",
  "WASM_COMPILED",
  "WASM_TO_JS",
  "JS_TO_WASM",
  "WASM_INTERPRETER_ENTRY",
  "C_WASM_ENTRY",
  "WASM_EXIT",
  "WASM_COMPILE_LAZY",
  "INTERPRETED",
  "STUB",
  "BUILTIN_CONTINUATION",
  "JAVA_SCRIPT_BUILTIN_CONTINUATION",
  "JAVA_SCRIPT_BUILTIN_CONTINUATION_WITH_CATCH",
  "INTERNAL",
  "CONSTRUCT",
  "ARGUMENTS_ADAPTOR",
  "BUILTIN",
  "BUILTIN_EXIT",
  "NATIVE",
)

# This set of constants is generated from a shipping build.
